<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">

<HTML>

<HEAD>
<TITLE>Numeraux de Church</TITLE>
<link REL="StyleSheet" TYPE="text/css" HREF="Costyle.css">

</HEAD>
<BODY BACKGROUND="../icons/arbk039.jpg">

<CENTER><H1>Intermezzo - (Cours/TD 6): Numéraux de Church</H1>
</CENTER>
<P>
<p>
<a href="javascript:back()"><IMG SRC="../icons/arltr.gif" WIDTH="31" HEIGHT="31" ALT="" border=0 align=absmiddle> <span class="en">&nbsp; (back) </span></a>

<p>
<FONT COLOR=#0000FF FACE="Helvetica,Arial" point-size=14pt>

<H3><FONT COLOR=#f00000>16.11.99</FONT></H3>
<p>


<H3>Ensemble de fonctions et exponentiation</H3>

Quel est le cardinal du <SPAN class=ib>powerset</SPAN> de <TT>[a,b,c,d]</TT>?
La réponse était immédiate :  16, 2<sup>4</sup>. J'ai reçu un peu moins d'informations en demandant "pourquoi?"...
<p>

Dans la théorie des ensembles, la collection de toutes les fonctions de A vers B : <B>A -&gt; B</B> est notée souvent comme <B>B<SUP>A</SUP></B>. On peut prouver que la taille de cet ensemble de fonctions, <B>|A -&gt;B|</B> est égale à <B>|B|<SUP>|A|</SUP></B> (bien sûr, si les ensembles sont finis). En effet, si A=[a,b], et B=[1,2,3], on peut énumérer les fonctions de <B>A</B> vers <B>B</B> :
<OL>
<LI> a -&gt; 1,  b -&gt; 1
<LI> a -&gt; 1,  b -&gt; 2
<LI> a -&gt; 1,  b -&gt; 3
<LI> a -&gt; 2,  b -&gt; 1
</OL>
etc. Pour chaque élément de <B>A</B> il y a <B>|B|</B> possibilités. Elles se multiplient, car elles sont indépendantes, et on obtient le résultat voulu. Ceci est la justification traditionnelle de la notation <B>B<SUP>A</SUP></B>. Elle ne semble pas être extrêmement "profonde". Nous montrerons à présent sur un modèle de calcul fonctionnel, que ce résultat est quand même un peu plus "intellectuel", voire même "cool".
<P>

<a name="arpeano"> </a>
<H3>Arithmétique de Peano</H3>

Il y a très longtemps (n'exagérons quand même pas ; Peano : 1858-1932) le mathématicien Peano a proposé un modèle de l'arithmétique de nombres naturels basé sur un nombre très limité d'entités et leur propriétés. Il suffit d'avoir le <I>zéro</I>, et le <I>successeur</I>. Le <I>zéro</I> est un nombre par définition, et tous les autres peuvent être obtenus par l'application du successeur. Bien sûr, cette vision inductive de l'arithmétique n'est pas très constructive. Il faut construire les opérations comme l'addition, la multiplication, etc. Elles doivent satisfaire quelques propriétés fondamentales, qui permettent leur <SPAN class=ib>définition récursive</SPAN>. Par exemple
<PRE class="he">
Zero + x = x
(Succ x) + y = x + (Succ y) = Succ (x + y)

Zero*x = Zero
(Succ x)*y = x*y + y
</PRE>
etc. Nous pouvons construire l'arithmétique de Peano (Alonzo Church n'est pas encore né... OK, peut-être, Church : 1903 - 1995) dans un langage de programmation qui permet la création de structures de données. Choisissons (pour vous surprendre) le langage Haskell. 
<PRE>
data Nr = Z | S Nr
</PRE>
C'est ça : un nombre est égal à zéro, ou il est successeur d'un autre nombre. Voici quelques opérations :
<PRE>
Z + x = x   -- Veeery cool ...
(S x) + y = x + (S y)
Z*x = Z
(S x)*y = x*y + y

uno = S Z   -- Au moins cela ...

x^Z = uno
x^(S y) = x*x^y
</PRE>
etc. La soustraction n'est pas si facile, on y reviendra. On obtient une sorte d'arithmétique "unaire", préhistorique. Notre ancêtre, le Gaulanthropus calculait comme ça. La seule représentation d'un nombre est un "sac de pierres" avec le nombre correspondant d'items. En tout cas, un langage avec la récursivité est capable de simuler l'arithmétique de Peano très facilement.
<p>


<H3>Numéraux de Peano-Church</H3>

Pour Alonzo Church, l'inventeur du calcul lambda, cette représentation était <I>trop concrète</I>. Il fallait avoir le constructeur de données, et la philosophie de Church était extrêmement abstraite. (Il ne voulait même pas avoir recours à la récursivité explicite...) Sachant que le concept d'abstraction philosophique signifie <I>la classe d'équivalences des objets concrets</I>, si on arrive à penser de manière abstraite, le raisonnement est applicable universellement, tel est le sens de l'opération "abstraire". Cela n'a rien à voir avec l'invention des choses non-existantes.
<p>

Donc Church a raisonné de manière suivante (bien sûr, ceci est ma transcription personnelle, un conte de fées spécialement pour vous):
<p>

<BLOCKQUOTE>
Le zéro et le successeur "existent", mais on n'a la moindre idée ce que c'est l'un ou autre. Le successeur est une abstraction fonctionnelle, car on peut l'appliquer, et zéro est une abstraction sans aucun attribut. <p>

Donc, toutes les manipulations des entités arithmétiques doivent <EM>être paramétrées</EM> par ces primitives. <SPAN class=ib>Chaque nombre est une fonction de deux paramètres - le zéro et le successeur</SPAN>.
</BLOCKQUOTE>
Et on commence à construire les nombres de Church. Le zéro (le "vrai", un nombre construit par nous) est une fonction du successeur "s" et de ce zéro mythique, inconnu "z", et il est évident que ce nombre ne dépend pas du tout du successeur. Alors :
<PRE>
zero s z = z
</PRE>
Le "un"?
<PRE>
one s z = s z
</PRE>
Ceci est la seule possibilité. On peut définir <TT>two s z = s (s z)</TT>, etc., mais c'est un peu fatigant. Voici quelques fonctions plus puissantes. Le successeur permettant de créer de "nombres réels" (numéraux) est une fonction qui agit sur un numéral et en produit un autre.
<PRE>
(succ n) s z = s (n s z)
</PRE>
ou, si vous voulez :
<PRE>
succ n s z = n s (s z)
</PRE>
grâce à l'associativité du successeur abstrait. (On utilise les deux formes, essayez de prouver leur équivalence. OK, je sais, <I>personne</I> ne va essayer. L'équivalence entre les deux formes devient presque évidente si on la reformule comme cela : <TT>s . (n s) = (n s) . s</TT>). Si la forme <TT>n s</TT> pour un <TT>n</TT> spécifié, signifie : appliquer <TT>s</TT> <TT>n</TT> fois (à quelque chose), l'addition peut être définie comme
<PRE>
add n1 n2 s z = n1 s (n2 s z)
</PRE>
On incrémente <TT>n1</TT> fois un objet qui est égal à  -  zéro incrémenté déjà <TT>n2</TT> fois. La multiplication est encore plus simple :
<PRE>
mul n1 n2 s z = n1 (n2 s) z
</PRE>
Démonstration? OK, elle n'est pas très rigoureuse, mais suffisante.
<PRE style="color:#0000B0">
add zero n s z = zero s (n s z) = n s z
add (succ n) m s z = succ n s (m s z) 
      = n s (s (m s z)) = n s (succ m s z)
      = add n (succ m) s z

mul zero n s z = zero (n s) z = z
mul (succ n) m s z = succ n (m s) z
      = m s (n (m s) z) = add m (mul n m s z) s z
</PRE>
Tout est en règle. L'application partielle <TT>(m s)</TT> est un "super-successeur" qui incrémente son argument <TT>m</TT> fois. Si on l'applique <TT>n</TT> fois, ceci équivaut à la multiplication. L'exponentiation est
<PRE>
expt n1 n2 s z = n2 n1 s z
</PRE>
Incroyable, mais vrai.  
<PRE style="color:#0000B0">
expt n zero s z = zero n s z = s z
expt n (succ m) s z = succ m n s z
   = n (m n s) z = n (expt n m s) z
   = mul n (expt n m) s z
</PRE>
Ce calcul est une perversion pure, on obtient des résultats classiques à partir de presque rien. <SPAN class=ib>La puissance est l'application fonctionnelle "à l'envers"</SPAN>. Notez qu'aucune des définitions des opérations arithmétiques n'est récursive ! Cependant la récursivité <SPAN class=ib>est là</SPAN>, "cachée". Où?
<p>

<H3>Numéraux et combinateurs</H3>

L'ordre normal - de gauche à droite, avec le parenthésage implicit de gauche à droite, a été utilisé ici plusieurs fois. Rappelons alors que ceci permet la suppression des arguments identiques de droite d'une définiction fonctionnelle. Par exemple, si <TT>one s x = s x</TT>, alors <TT>one s = s</TT>. On ne peut plus continuer pour des raisons syntaxiques. Mais on voit que <TT>one = id</TT>, la fonction identité qui ne fait rien avec son argument. Notre nombre "1" de Church devient un simple combinateur, défini sans paramètres. Et le zéro : <TT>zero s z = z</TT>? 
<p>

<SPAN class=ib>La technique de transformation combinatoire simplifie les combinaisons de fonctions, et trouve sa place dans le domaine de compilation, surtout la compilation des langages fonctionnels. Il faut commencer par un petit nombre de combinateurs primitifs, de base.</SPAN> Normalement, on utilise l'identité, la constante, et l'opérateur d'échange des arguments d'une fonction. Définissons-les en Haskell :
<PRE>
const x y = x
flip f x y = f y x
</PRE>
On voit à présent que <TT>zero = flip const</TT>. En effet, <TT>flip const s z = const z s = z</TT>. La définition combinatoire de l'exponentiation est
<PRE>
expt n1 n2 = n2 n1
</PRE>
indépendamment de <TT>s</TT> et <TT>z</TT>. La multiplication peut être réduite à
<PRE>
mul n1 n2 = n1 . n2
</PRE>
Alors, la multiplication  <SPAN class=ib>est</SPAN> la composition fonctionnelle. Ceci correspond bien au fait que "1" est l'identité. Pour la puissance : <TT>expt n one</TT>, et ceci se réduit à <TT>one n = n</TT>. D'autres exercices, et l'introduction de deux autres combinateurs primitifs : <TT>dupl</TT> et <TT>subst</TT> vous attend prochaînement. Oui, oui, ce sujet a son application dans le domaine de compilation.
<p>
Pour terminer la discussion des numéraux de Church

<a name="fundata"> </a>
<H3>Un bon Fonctionnaliste n'a pas besoin de données</H3>

Nous avons découvert que
<UL type="disc">
<LI> Les nombres, qui "classiquement" sont des structures de données "irréductibles", primitives, peuvent être considérés comme des structures de données composites, engendrés par le constructeur <TT>Succ</TT>.

<LI> Dans un formalisme fonctionnel élaboré par Church, on n'a pas besoin de ce constructeur. Tout est application fonctionnelle.
</UL>
Mieux, on peut montrer comment éliminer <B>tous</B> les constructeurs d'un langage ! Ceci n'est pas vraiment pratique, et ressemble plutôt à un "jeu" théorique, mais parfois facilite quelques preuves, et transformations des programmes. Construisons en Haskell l'équivalent de l'opération <TT>(,)</TT>, la création d'une paire. (Si on arrive à faire ça, on pourra faire presque tout...). Définissons
<PRE>
cons a b s = s a b

car x = x const
cdr x = x (flip const)
</PRE>
Maintenant <TT>xx = cons 1 2.0</TT> construit une "structure de données" abstraite, un objet totalement opaque, dont le contenu n'est pas visible directement. Mais  si on lui applique la fonction <TT>car</TT>, le combinateur <TT>const</TT> agissant sur les deux valeurs stockées dans la fermeture crée par <TT>cons</TT>, récupère le premier membre, et <TT>cdr</TT> en récupère le deuxième. On peut composer ces opérations, p. ex. <TT>yy = cons xx (cons True "Belle Marquise")</TT>. Nous avons "rédécouvert" les listes Lisp. Non, en fait, mieux : nous les avons <SPAN class=ib>réinventées</SPAN>.
<p>

Le formalisme fonctionnel permet donc de simuler les structures de données composites. Je répète : ceci n'est pas une méthode extrêmement efficace, mais souvent on peut très facilement, et par un code très court et lisible stocker dans les fermetures l'information, qui nécessiterait la construction des données <i>ad hoc</i>. La technique proposée permet d'économiser le <I>temps humain</I>.




<H3>Derniers commentaires</H3>

<EM>SVP, regardez ici de temps en temps. Prochaînement je brancherai le second volet de cette discussion.</EM> Nous allons discuter la définition de la soustraction, et autres choses intéressantes, comme le concept de la récursivité réalisé à travers le "combinateur paradoxal".
<p>


<p>
<a href="javascript:back()"><IMG SRC="../icons/arltr.gif" WIDTH="31" HEIGHT="31" ALT="" border=0 align=absmiddle> <span class="en">&nbsp; (back) </span></a>
<p>


</FONT>
</BODY>

</HTML>
